Subject: Re: [bitcoin-dev] For discussion: limit transaction size to mitigate CVE-2013-2292

From: Gregory Maxwell <[email-masked]>
Date: Mon, 20 Jul 2015 20:55:57 +0000

On Mon, Jul 20, 2015 at 7:10 PM, Gavin Andresen via bitcoin-dev
<[email-masked]> wrote:
> Mitigate a potential CPU exhaustion denial-of-service attack by limiting
> the maximum size of a transaction included in a block.

This seems like a fairly indirect approach. The resource being watched
for is not the size (otherwise two transactions for 200k would be
strictly worse than one 200k transactions) but the potential of N^2
costs related to repeated hashing in checksig; which this ignores.

The cost of the indirection is forclosing future applications which
involve larger signatures but have no quadratic component and are thus
fast to verify-- or requring yet another hard fork to remove the
limit, or a kludgy soft fork that splits the same data across two
"transactions" which get processed as a unit... all would be
unfortunate.

Alternative 1 sounds more attractive to be for this reason as it's more direct.